//
// Class for greens function
// (c) 15.3.2006 Ingo D. Rullhusen
//

#ifndef GREEN_FREESPACE_H 
#define GREEN_FREESPACE_H

#include <complex>

#include "point.h"

using namespace std;


class GREEN
{
   public:
      GREEN( double k0 );

      void EP_green( complex<double> grfv[3][3], complex<double> &grfdiv,
                     const POINT ap, const POINT qp );

      void EP_green_ex( complex<double> pv[3], complex<double> &gdiv,
                        const complex<double> J[3], complex<double> div,       
                        const complex<double> J0[3], complex<double> div0,
                        const POINT ap, const POINT qp );

      void EP_green_re( complex<double> pv[3], complex<double> &div, 
                        const complex<double> J0[3], complex<double> div0,
                        const POINT tp1,
                           const POINT tp2,
                              const POINT tp3,
                        const POINT ap );

   private:
      double k0;

      double prefac_v;
      double prefac_div;
      double prefac_E;
      complex<double> prefac_ff;

};

#endif
