//
// module data
// (c) 2.11.2006 Ingo D. Rullhusen
//

#ifndef MODULE_DATA_H
#define MODULE_DATA_H

#include <GL/gl.h>

#include <string>

#include "point.h"
#include "green.h"

using namespace std;


struct TRIANGLE
{
   int p1, p2, p3;
   int ve1, ve2, ve3;
   struct
   {
      signed short sp1:2;  // -1; 0; +1
      signed short sp2:2;  // -1; 0; +1
      signed short sp3:2;  // -1; 0; +1
   } sign;
};

typedef vector<TRIANGLE> TRIANGLE_LIST;


struct vEDGE
{
   int p1, p2;
   int spp, spm;
   int trip, trim;
};

typedef vector<vEDGE> vEDGE_LIST;




class ModuleData
{
   public:

// matrix
      string off_file_name;
      double mesh_unit;
      double cp_x, cp_y, cp_z;
      double theta, phi, psi;

      GREEN *grf;

      POINT_LIST     plist;
      TRIANGLE_LIST  tlist;
      vEDGE_LIST     velist;

// extract
      string J_probe_file_name;
      double startpkt[3];
      int noofpkt;
      double endpkt[3];
      double extract_psi;

      double lv[3], c1v[3], c2v[3];


      ModuleData();
      ModuleData( const ModuleData *d );
      ~ModuleData();

      void read_off_file();
#ifdef HAVE_LIBGL
      void ogl_triangles( GLuint list );
#endif

      void triangle_center( int tno, POINT &p ) const;
      bool triangle_neigh( int tno1, int tno2 ) const;
      double triangle_area( int tno ) const;
      double triangle_normal( int tno, double &nx, double &ny, double &nz ) const;
      int near_triangle( POINT &p ) const;

      void setup_exvec();
};


#endif
