//
// gANTlab test module I --- E J out
// (c) 28.6.2007 Ingo D. Rullhusen
//

#include <stdio.h>
#include <float.h>

#include <iostream>

#include "module_header.h"

#include "vect.h"
#include "module_data1.h"

using namespace std;



int MainData_version      = MainData_version_;
int FIELD_version         = FIELD_version_;
int module_header_version = module_header_version_;



int version = 1;
char *name = "Test Module I";



extern "C" void* new_data(){ return( (void*) new ModuleData ); }

extern "C" void* dpl_data( void *di_ ){ return( (void*) new ModuleData( (ModuleData*)di_ ) ); }

extern "C" void del_data( void *di_ ){ delete (ModuleData*)di_; }




const int extract_para_no = 3;
const char *extract_para[ extract_para_no ] =
{ 
   "J vect file",
   "Einc vect file",
   "Escatt vect file"
};


extern "C" void extract_get_parameter( const MainData *MD, void *data_,
                                       string **param, string **value,
                                       int *no )
{
   ModuleData *data = (ModuleData*)data_;

   *no = extract_para_no;
   *param = new string[*no];
   *value = new string[*no];   

   int id = 0;

   (*param)[id] = extract_para[id];
   (*value)[id] = data->J_vect_filename;
   id++;

   (*param)[id] = extract_para[id];
   (*value)[id] = data->Einc_vect_filename;
   id++;

   (*param)[id] = extract_para[id];
   (*value)[id] = data->Escatt_vect_filename;
   id++;

}

extern "C" void extract_set_parameter( const MainData *MD, void *data_,
                                       const string *param, const string *value,
                                       int no )
{
   ModuleData *data = (ModuleData*)data_;
   int j;

   for ( int i=0; i<no; i++ )
   {
      for ( j=0; j<extract_para_no; j++ ) if ( extract_para[j] == param[i] ) break;

      switch(j)
      {
         case 0: { data->J_vect_filename = value[i]; break; }
         case 1: { data->Einc_vect_filename = value[i]; break; }
         case 2: { data->Escatt_vect_filename = value[i]; break; }
         default: throw( "unknown parameter" );
      }
   }

}


extern "C" void extract_run( const MainData *MD, void *data_, bool dummy,
                             complex<double> *JV, int no, const FIELD *f,
                             string **omsg, int *nomsg )
{
   ModuleData *data = (ModuleData*)data_;
   int fidx;
   double R, r;
   POLY p;
   POLYLIST pl;

//
// J
   if ( data->J_vect_filename != "" )
   {

   R = 0;
   for ( int i3=0; i3<f->noz; i3++ )
   {
      for ( int i2=0; i2<f->noy; i2++ )
      {
         for ( int i1=0; i1<f->nox; i1++ )
         {
            fidx = i1 + f->nox * i2 + f->nox*f->noy * i3;

            r = sqrt( f->J[fidx].x.real() * f->J[fidx].x.real()
                      + f->J[fidx].y.real() * f->J[fidx].y.real()
                      + f->J[fidx].z.real() * f->J[fidx].z.real() );

            if ( r > R ) R = r;

            r = sqrt( f->J[fidx].x.imag() * f->J[fidx].x.imag()
                      + f->J[fidx].y.imag() * f->J[fidx].y.imag()
                      + f->J[fidx].z.imag() * f->J[fidx].z.imag() );

            if ( r > R ) R = r;

         }
      }
   }

   R = ( R > DBL_MIN ? 0.9 * sqrt( f->delta_x*f->delta_x
                                   + f->delta_y*f->delta_y
                                   + f->delta_z*f->delta_z ) / R
                     : 0.0 );

   pl.clear();

   for ( int i3=0; i3<f->noz; i3++ )
   {
      for ( int i2=0; i2<f->noy; i2++ )
      {
         for ( int i1=0; i1<f->nox; i1++ )
         {
            fidx = i1 + f->nox * i2 + f->nox*f->noy * i3;

            p = POLY( 2, 255, 0, 0 );
            p.x[0] = i1*f->delta_x + f->lpos_x;
            p.y[0] = i2*f->delta_y + f->lpos_y;
            p.z[0] = i3*f->delta_z + f->lpos_z;

            p.x[1] = p.x[0] + f->J[fidx].x.real()*R;
            p.y[1] = p.y[0] + f->J[fidx].y.real()*R;
            p.z[1] = p.z[0] + f->J[fidx].z.real()*R;

            pl.push_back(p);


            p = POLY( 2, 0, 0, 255 );
            p.x[0] = i1*f->delta_x + f->lpos_x;
            p.y[0] = i2*f->delta_y + f->lpos_y;
            p.z[0] = i3*f->delta_z + f->lpos_z;

            p.x[1] = p.x[0] + f->J[fidx].x.imag()*R;
            p.y[1] = p.y[0] + f->J[fidx].y.imag()*R;
            p.z[1] = p.z[0] + f->J[fidx].z.imag()*R;

            pl.push_back(p);

         }
      }
   }

   vect_out( data->J_vect_filename, &pl );

   }

//
// Einc
   if ( data->Einc_vect_filename != "" )
   {

   R = 0;
   for ( int i3=0; i3<f->noz; i3++ )
   {
      for ( int i2=0; i2<f->noy; i2++ )
      {
         for ( int i1=0; i1<f->nox; i1++ )
         {
            fidx = i1 + f->nox * i2 + f->nox*f->noy * i3;

            r = sqrt( f->Einc[fidx].x.real() * f->Einc[fidx].x.real()
                      + f->Einc[fidx].y.real() * f->Einc[fidx].y.real()
                      + f->Einc[fidx].z.real() * f->Einc[fidx].z.real() );

            if ( r > R ) R = r;

            r = sqrt( f->Einc[fidx].x.imag() * f->Einc[fidx].x.imag()
                      + f->Einc[fidx].y.imag() * f->Einc[fidx].y.imag()
                      + f->Einc[fidx].z.imag() * f->Einc[fidx].z.imag() );

            if ( r > R ) R = r;

         }
      }
   }

   R = ( R > DBL_MIN ? 0.9 * sqrt( f->delta_x*f->delta_x
                                   + f->delta_y*f->delta_y
                                   + f->delta_z*f->delta_z ) / R
                     : 0.0 );

   pl.clear();

   for ( int i3=0; i3<f->noz; i3++ )
   {
      for ( int i2=0; i2<f->noy; i2++ )
      {
         for ( int i1=0; i1<f->nox; i1++ )
         {
            fidx = i1 + f->nox * i2 + f->nox*f->noy * i3;

            p = POLY( 2, 255, 0, 0 );
            p.x[0] = i1*f->delta_x + f->lpos_x;
            p.y[0] = i2*f->delta_y + f->lpos_y;
            p.z[0] = i3*f->delta_z + f->lpos_z;

            p.x[1] = p.x[0] + f->Einc[fidx].x.real()*R;
            p.y[1] = p.y[0] + f->Einc[fidx].y.real()*R;
            p.z[1] = p.z[0] + f->Einc[fidx].z.real()*R;

            pl.push_back(p);


            p = POLY( 2, 0, 0, 255 );
            p.x[0] = i1*f->delta_x + f->lpos_x;
            p.y[0] = i2*f->delta_y + f->lpos_y;
            p.z[0] = i3*f->delta_z + f->lpos_z;

            p.x[1] = p.x[0] + f->Einc[fidx].x.imag()*R;
            p.y[1] = p.y[0] + f->Einc[fidx].y.imag()*R;
            p.z[1] = p.z[0] + f->Einc[fidx].z.imag()*R;

            pl.push_back(p);

         }
      }
   }

   vect_out( data->Einc_vect_filename, &pl );

   }

//
// Escatt
   if ( data->Escatt_vect_filename != "" )
   {

   R = 0;
   for ( int i3=0; i3<f->noz; i3++ )
   {
      for ( int i2=0; i2<f->noy; i2++ )
      {
         for ( int i1=0; i1<f->nox; i1++ )
         {
            fidx = i1 + f->nox * i2 + f->nox*f->noy * i3;

            r = sqrt( f->Escatt[fidx].x.real() * f->Escatt[fidx].x.real()
                      + f->Escatt[fidx].y.real() * f->Escatt[fidx].y.real()
                      + f->Escatt[fidx].z.real() * f->Escatt[fidx].z.real() );

            if ( r > R ) R = r;

            r = sqrt( f->Escatt[fidx].x.imag() * f->Escatt[fidx].x.imag()
                      + f->Escatt[fidx].y.imag() * f->Escatt[fidx].y.imag()
                      + f->Escatt[fidx].z.imag() * f->Escatt[fidx].z.imag() );

            if ( r > R ) R = r;

         }
      }
   }

   R = ( R > DBL_MIN ? 0.9 * sqrt( f->delta_x*f->delta_x
                                   + f->delta_y*f->delta_y
                                   + f->delta_z*f->delta_z ) / R
                     : 0.0 );

   pl.clear();

   for ( int i3=0; i3<f->noz; i3++ )
   {
      for ( int i2=0; i2<f->noy; i2++ )
      {
         for ( int i1=0; i1<f->nox; i1++ )
         {
            fidx = i1 + f->nox * i2 + f->nox*f->noy * i3;

            p = POLY( 2, 255, 0, 0 );
            p.x[0] = i1*f->delta_x + f->lpos_x;
            p.y[0] = i2*f->delta_y + f->lpos_y;
            p.z[0] = i3*f->delta_z + f->lpos_z;

            p.x[1] = p.x[0] + f->Escatt[fidx].x.real()*R;
            p.y[1] = p.y[0] + f->Escatt[fidx].y.real()*R;
            p.z[1] = p.z[0] + f->Escatt[fidx].z.real()*R;

            pl.push_back(p);


            p = POLY( 2, 0, 0, 255 );
            p.x[0] = i1*f->delta_x + f->lpos_x;
            p.y[0] = i2*f->delta_y + f->lpos_y;
            p.z[0] = i3*f->delta_z + f->lpos_z;

            p.x[1] = p.x[0] + f->Escatt[fidx].x.imag()*R;
            p.y[1] = p.y[0] + f->Escatt[fidx].y.imag()*R;
            p.z[1] = p.z[0] + f->Escatt[fidx].z.imag()*R;

            pl.push_back(p);

         }
      }
   }

   vect_out( data->Escatt_vect_filename, &pl );

   }


   *nomsg = 0;
   *omsg = NULL;
}

