//
// AIM data class
// (c) 25.8.2006 Ingo D. Rullhusen
//

#ifndef AIMDATA_H
#define AIMDATA_H

#include <fstream>

#include "maindatax.h"
#include "module_interface.h"


typedef float AIMreal;

class AIMData
{
   public:
      int nox, noy, noz;
      AIMreal *lambda_x, *lambda_y, *lambda_z,
              *lambda_div;   // i + nox*j + nox*noy*k

      int x_off, y_off, z_off;

      AIMData( MainDataX MD, const ExternalModule *M, int nobfkt );
      AIMData( const AIMData &AD2 );
      AIMData();
      ~AIMData();

      AIMData( fstream &file );
      void write_binary( fstream &file ) const;
      int index( int ix, int iy, int iz ) const;

      AIMData& operator =( const AIMData AD2 );
};


#endif
