//
// Class for field grid
// (c) 28.3.2006 Ingo D. Rullhusen
//


#ifndef AIMFIELD_H
#define AIMFIELD_H

#include <fftw3.h>

#include <complex>

#include "aimdata.h"

using namespace std;


class AIMfield
{
   public:
      bool transformed;
      int nox, noy, noz, noxy, noxyz;
      complex<double> *X, *Y, *Z, *div;

      AIMfield( const int nx, const int ny, const int nz );
      ~AIMfield();

      void FFT();
      void IFFT();

      void set2zero( bool transformed = false );
      void add( complex<double> fac, AIMData ad );

      void mult_lambda( complex<double> *vp, complex<double> *phi,
                        AIMData *ad );

   private:
      fftw_plan pX, pY, pZ, pdiv;
      fftw_plan IpX, IpY, IpZ, Ipdiv;
};


#endif
