//
// Base class for 2D drawings
// (c) 24.5.2006 Ingo D. Rullhusen
//

#ifndef DRAWING_H
#define DRAWING_H

#include <qcanvas.h>
#include <qwidget.h>

class Drawing : public QCanvasView
{
   Q_OBJECT
   Q_PROPERTY( QColor BackgroundColor READ BkgColor WRITE setBkgColor )
     
public:
   Drawing( QWidget *parent = 0, const char *name = 0 );
   ~Drawing();
    
   QCanvas canvas;

   QColor BkgColor() const;
    
public slots:
   void setBkgColor( QColor c );
   void clear();

signals:
   void mouseButtonPressed( QMouseEvent* e );
   void mouseMoved( QMouseEvent* e );
   void resized();

protected:
   void mousePressEvent( QMouseEvent* e );
   void mouseMoveEvent( QMouseEvent* e );
   void viewportResizeEvent( QResizeEvent* re );
};


#endif
