/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/


#include "global_vars.h"

#include "auxiliary_qt.h"


void Extraction::getMD()
{
   int m;
   double value;


   Coeff->setChecked( MD.coeff );
   while( Coeff_numbering->count() > 0 ) Coeff_numbering->removeItem(0);
   Coeff_numbering->insertItem( "global" );
   m = 1;
   for ( vector<ExternalModule>::iterator ip = used_modules.begin();
         ip != used_modules.end();
         ip++ )
   {
      Coeff_numbering->insertItem( QString::number(m) + ": " + ip->name() );
      m++;
   }
   Coeff_numbering->setCurrentItem( MD.coeff_numbering );
   Coeff_vec->setCurrentItem( MD.coeff_vec );
   Coeff_from->setText( sysLocale.toString(MD.coeff_from) );
   Coeff_to->setText( sysLocale.toString(MD.coeff_to) );


   NearField->setChecked( MD.near_field );
   value = LengthUnitFactor(nfpUnit->currentText());
   nfp_x->setText( sysLocale.toString(MD.nfp_x*value, 'g', 10) );
   nfp_y->setText( sysLocale.toString(MD.nfp_y*value, 'g', 10) );
   nfp_z->setText( sysLocale.toString(MD.nfp_z*value, 'g', 10) );

   old_nfpU = nfpUnit->currentText();

   FarField->setChecked( MD.far_field );
   pad_x->setText( sysLocale.toString(MD.pad_x) );
   pad_y->setText( sysLocale.toString(MD.pad_y) );
   pad_z->setText( sysLocale.toString(MD.pad_z) );
   itpl_deg->setText( sysLocale.toString(MD.itpl_deg) );
   noTheta->setText( sysLocale.toString(MD.no_theta) );
   noPhi->setText( sysLocale.toString(MD.no_phi) );
   RadPwr->setChecked( MD.radiated_pwr );

}


void Extraction::setMD()
{
   double value;

   MD.coeff = Coeff->isChecked();
   MD.coeff_numbering = Coeff_numbering->currentItem();
   MD.coeff_vec = Coeff_vec->currentItem();
   MD.coeff_from = sysLocale.toInt(Coeff_from->text());
   MD.coeff_to = sysLocale.toInt(Coeff_to->text());

   MD.coeff_from = ( MD.coeff_from < 0 ? 0 : MD.coeff_from );
   MD.coeff_to = ( MD.coeff_to < 0 ? 0 : MD.coeff_to );


   MD.near_field = NearField->isChecked();
   value = 1.0 / LengthUnitFactor(nfpUnit->currentText());
   MD.nfp_x = sysLocale.toDouble(nfp_x->text()) * value;
   MD.nfp_y = sysLocale.toDouble(nfp_y->text()) * value;
   MD.nfp_z = sysLocale.toDouble(nfp_z->text()) * value;


   MD.far_field = FarField->isChecked();
   if ( MD.AIMnox != 1 )
      MD.pad_x = sysLocale.toInt(pad_x->text());
   else
      MD.pad_x = 0;
   if ( MD.AIMnoy != 1 )
      MD.pad_y = sysLocale.toInt(pad_y->text());
   else
      MD.pad_y = 0;
   if ( MD.AIMnoz != 1 )
      MD.pad_z = sysLocale.toInt(pad_z->text());
   else
      MD.pad_z = 0;
   MD.itpl_deg = sysLocale.toInt(itpl_deg->text());

   MD.pad_x = ( MD.pad_x < 0 ? 0 : MD.pad_x );
   MD.pad_y = ( MD.pad_y < 0 ? 0 : MD.pad_y );
   MD.pad_z = ( MD.pad_z < 0 ? 0 : MD.pad_z );

   MD.itpl_deg = ( MD.itpl_deg < 0 ? 0 : MD.itpl_deg );


   MD.no_theta =sysLocale.toInt( noTheta->text());
   MD.no_phi = sysLocale.toInt(noPhi->text());
   MD.radiated_pwr = RadPwr->isChecked();

   MD.no_theta = ( MD.no_theta < 2 ? 2 : MD.no_theta );
   MD.no_phi = ( MD.no_phi < 1 ? 1 : MD.no_phi );
}



void Extraction::recalcUnits()
{
   double value;

   value = LengthUnitFactor(nfpUnit->currentText()) / LengthUnitFactor(old_nfpU);
   nfp_x->setText( sysLocale.toString( sysLocale.toDouble(nfp_x->text()) * value, 'g', 10) );
   nfp_y->setText( sysLocale.toString( sysLocale.toDouble(nfp_y->text()) * value, 'g', 10) );
   nfp_z->setText( sysLocale.toString( sysLocale.toDouble(nfp_z->text()) * value, 'g', 10) );
   old_nfpU = nfpUnit->currentText();
}




void Extraction::openHelp()
{
   ptrMW->qac->showPage( root_path + "/doc/html/gantlab-3.html" );
}

