/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/


#include "global_vars.h"


double gANTlabProject::frequency()
{
   QString str = FreqWlSelect->currentText();
   if ( str == tr("frequency") )
   {
      return( sysLocale.toDouble(lineEditFreqWl->text())/FreqUnitFactor(FreqUnit->currentText()) );
   }
   else if ( str == tr("wavelength") )
   {
      return( C0*LengthUnitFactor(wlUnit->currentText())/sysLocale.toDouble(lineEditFreqWl->text()) );
   }

   throw( "freq/wl select error" );
}


double gANTlabProject::wavelength()
{
   QString str = FreqWlSelect->currentText();
   if ( str == tr("frequency") )
   {
      return( C0*FreqUnitFactor(FreqUnit->currentText())/sysLocale.toDouble(lineEditFreqWl->text()) );
   }
   else if ( str == tr("wavelength") )
   {
      return( sysLocale.toDouble(lineEditFreqWl->text())/LengthUnitFactor(wlUnit->currentText()) );
   }

   throw( "freq/wl select error" );
}


void gANTlabProject::recalcUnits()
{
   double value;
   QString str;

   str = FreqWlSelect->currentText();
   if ( str == tr("frequency") )
   {
      value = sysLocale.toDouble(lineEditFreqWl->text()) / FreqUnitFactor(old_FU);
      lineEditFreqWl->setText( sysLocale.toString(value*FreqUnitFactor(FreqUnit->currentText()),'g',10) );

      old_FU = FreqUnit->currentText();
   }
   else if ( str == tr("wavelength") )
   {
      value = sysLocale.toDouble(lineEditFreqWl->text()) / LengthUnitFactor(old_wlU);
      lineEditFreqWl->setText( sysLocale.toString(value*LengthUnitFactor(wlUnit->currentText()),'g',10) );

      old_wlU = wlUnit->currentText();
   }
   else throw( "freq/wl select error" );


   value = LengthUnitFactor(posUnit->currentText()) / LengthUnitFactor(old_posU);
   AIMcenterX->setText( sysLocale.toString( sysLocale.toDouble(AIMcenterX->text())*value, 'g', 10) );
   AIMcenterY->setText( sysLocale.toString( sysLocale.toDouble(AIMcenterY->text())*value, 'g', 10) );
   AIMcenterZ->setText( sysLocale.toString( sysLocale.toDouble(AIMcenterZ->text())*value, 'g', 10) );

   old_posU = posUnit->currentText();

   value = LengthUnitFactor(sizeUnit->currentText()) / LengthUnitFactor(old_sizeU);
   AIMsizeX->setText( sysLocale.toString( sysLocale.toDouble(AIMsizeX->text())*value, 'g', 10) );
   AIMsizeY->setText( sysLocale.toString( sysLocale.toDouble(AIMsizeY->text())*value, 'g', 10) );
   AIMsizeZ->setText( sysLocale.toString( sysLocale.toDouble(AIMsizeZ->text())*value, 'g', 10) );

   old_sizeU = sizeUnit->currentText();


   str = KoD->currentText();
   if ( str == tr("discretization") && old_Discr == tr("pnts per wl") )
   {
      value = LengthUnitFactor(sizeUnit->currentText()) / wavelength();
      AIMdiscX->setText( sysLocale.toString( (int)rint( sysLocale.toDouble(AIMdiscX->text())*sysLocale.toDouble(AIMsizeX->text())*value) ) );
      AIMdiscY->setText( sysLocale.toString( (int)rint( sysLocale.toDouble(AIMdiscY->text())*sysLocale.toDouble(AIMsizeY->text())*value) ) );
      AIMdiscZ->setText( sysLocale.toString( (int)rint( sysLocale.toDouble(AIMdiscZ->text())*sysLocale.toDouble(AIMsizeZ->text())*value) ) );

      old_Discr = str;
   }
   else if ( str == tr("pnts per wl") && old_Discr == tr("discretization") )
   {
      value = wavelength() / LengthUnitFactor(sizeUnit->currentText());
      AIMdiscX->setText( sysLocale.toString( sysLocale.toDouble(AIMdiscX->text())*value/sysLocale.toDouble(AIMsizeX->text()), 'g', 10) );
      AIMdiscY->setText( sysLocale.toString( sysLocale.toDouble(AIMdiscY->text())*value/sysLocale.toDouble(AIMsizeY->text()), 'g', 10) );
      AIMdiscZ->setText( sysLocale.toString( sysLocale.toDouble(AIMdiscZ->text())*value/sysLocale.toDouble(AIMsizeZ->text()), 'g', 10) );

      old_Discr = str;
   }

}



void gANTlabProject::getMD()
{

   lineEditPrj->setText( MD.PrjPath );
   lineEditPrjTmp->setText( MD.PrjTmpPath );
   lineEditModules->setText( MD.ModulePath );


   AIMcorrectionMode->setCurrentItem( MD.AIMcm );
   PreconProfile->setText( sysLocale.toString(MD.precon) );
   Epsilon->setText( sysLocale.toString(MD.epsilon, 'g', 10) );
   itno->setText( sysLocale.toString(MD.max_itno) );


   getFreqWl();


   AIMcenterX->setText( sysLocale.toString(MD.cpos_x*LengthUnitFactor(posUnit->currentText()), 'g', 10) );
   AIMcenterY->setText( sysLocale.toString(MD.cpos_y*LengthUnitFactor(posUnit->currentText()), 'g', 10) );
   AIMcenterZ->setText( sysLocale.toString(MD.cpos_z*LengthUnitFactor(posUnit->currentText()), 'g', 10) );

   AIMsizeX->setText( sysLocale.toString(MD.size_x*LengthUnitFactor(sizeUnit->currentText()), 'g', 10) );
   AIMsizeY->setText( sysLocale.toString(MD.size_y*LengthUnitFactor(sizeUnit->currentText()), 'g', 10) );
   AIMsizeZ->setText( sysLocale.toString(MD.size_z*LengthUnitFactor(sizeUnit->currentText()), 'g', 10) );

   QString str = KoD->currentText();
   if ( str == tr("discretization") )
   {
      AIMdiscX->setText( sysLocale.toString(MD.AIMnox) );
      AIMdiscY->setText( sysLocale.toString(MD.AIMnoy) );
      AIMdiscZ->setText( sysLocale.toString(MD.AIMnoz) );
   }
   else if ( str == tr("pnts per wl") )
   {
      AIMdiscX->setText( sysLocale.toString(MD.AIMnox*wavelength()/MD.size_x, 'g', 10) );
      AIMdiscY->setText( sysLocale.toString(MD.AIMnoy*wavelength()/MD.size_y, 'g', 10) );
      AIMdiscZ->setText( sysLocale.toString(MD.AIMnoz*wavelength()/MD.size_z, 'g', 10) );
   }
   else throw( "discretization select error" );


   old_FU = FreqUnit->currentText();
   old_wlU = wlUnit->currentText();

   old_posU = posUnit->currentText();
   old_sizeU = sizeUnit->currentText();
   old_Discr = KoD->currentText();

   NearLimit->setText( sysLocale.toString(MD.near_limit, 'g', 10) );
}


void gANTlabProject::getFreqWl()
{
   QString str = FreqWlSelect->currentText();
   if ( str == tr("frequency") )
   {
      lineEditFreqWl->setText( sysLocale.toString(MD.freq*FreqUnitFactor(FreqUnit->currentText()), 'g', 10) );
   }
   else if ( str == tr("wavelength") )
   {
      lineEditFreqWl->setText( sysLocale.toString(MD.wavelength*LengthUnitFactor(wlUnit->currentText()), 'g', 10) );
   }
   else throw( "freq/wl select error" );
}


void gANTlabProject::setMD()
{
   double value;
   QString str;

   MD.freq = frequency();
   MD.wavelength = wavelength();
   MD.omega = 2.0 * M_PI * MD.freq;
   MD.k0 = 2.0 * M_PI / MD.wavelength;


   value = 1.0 / LengthUnitFactor(posUnit->currentText());
   MD.cpos_x = sysLocale.toDouble(AIMcenterX->text()) * value;
   MD.cpos_y = sysLocale.toDouble(AIMcenterY->text()) * value;
   MD.cpos_z = sysLocale.toDouble(AIMcenterZ->text()) * value;


   value = 1.0 / LengthUnitFactor(sizeUnit->currentText());
   MD.size_x = sysLocale.toDouble(AIMsizeX->text()) * value;
   MD.size_y = sysLocale.toDouble(AIMsizeY->text()) * value;
   MD.size_z = sysLocale.toDouble(AIMsizeZ->text()) * value;

   str = KoD->currentText();
   if ( str == tr("discretization") )
   {
      MD.AIMnox = sysLocale.toInt(AIMdiscX->text());
      MD.AIMnoy = sysLocale.toInt(AIMdiscY->text());
      MD.AIMnoz = sysLocale.toInt(AIMdiscZ->text());
   }
   else if ( str == tr("pnts per wl") )
   {
      value = LengthUnitFactor(sizeUnit->currentText()) / wavelength();
      MD.AIMnox = (int)rint( sysLocale.toDouble(AIMdiscX->text()) * sysLocale.toDouble(AIMsizeX->text()) * value);
      MD.AIMnoy = (int)rint( sysLocale.toDouble(AIMdiscY->text()) * sysLocale.toDouble(AIMsizeY->text()) * value);
      MD.AIMnoz = (int)rint( sysLocale.toDouble(AIMdiscZ->text()) * sysLocale.toDouble(AIMsizeZ->text()) * value);
   }
   else throw( "discretization select error" );

   MD.AIMnox = ( MD.AIMnox < 1 ? 1 : MD.AIMnox );
   MD.AIMnoy = ( MD.AIMnoy < 1 ? 1 : MD.AIMnoy );
   MD.AIMnoz = ( MD.AIMnoz < 1 ? 1 : MD.AIMnoz );

   MD.delta_x = ( MD.AIMnox > 1 ? MD.size_x / ( MD.AIMnox - 1 ) : 0.0 );
   MD.delta_y = ( MD.AIMnoy > 1 ? MD.size_y / ( MD.AIMnoy - 1 ) : 0.0 );
   MD.delta_z = ( MD.AIMnoz > 1 ? MD.size_z / ( MD.AIMnoz - 1 ) : 0.0 );

   MD.near_limit = sysLocale.toDouble(NearLimit->text());


   MD.AIMcm = (AIMcorrMode)AIMcorrectionMode->currentItem();
   MD.precon = sysLocale.toInt(PreconProfile->text());
   MD.max_itno = sysLocale.toInt(itno->text());
   MD.epsilon = sysLocale.toDouble(Epsilon->text());


   MD.PrjPath = (const char*)lineEditPrj->text();
   MD.PrjTmpPath = (const char*)lineEditPrjTmp->text();
   MD.ModulePath = (const char*)lineEditModules->text();
}


void gANTlabProject::openHelp()
{
   ptrMW->qac->showPage( root_path + "/doc/html/gantlab.html" );
}

