//
// global variables
// (c) 30.4.2007 Ingo D. Rullhusen
//


#ifndef GLOBAL_VARS_H
#define GLOBAL_VARS_H


#include <vector>

#ifndef TERMINAL

#include <qassistantclient.h>

#include "logstream.h"
#include "mainform.h"

#else

#include <iostream>
#define Xlog std::cout

#endif


#include <qapplication.h>
#include <qtextcodec.h>
#include <qstring.h>
#include <qlocale.h>

#include "maindatax.h"
#include "module_interface.h"
#include "state.h"
#include "aimdata.h"
#include "nearmatrix.h"
#include "aimsolver.h"
#include "green.h"


#ifdef DEFINE_GLOBAL_VARS


#include <new>

#define EXT_ 

#ifndef TERMINAL
LOGstream Xlog;
#endif

void gantlab_new_error_handler()
{
   std::bad_alloc BA;  // old compilers
   Xlog << "memory allocation failure!" << endl;
   throw(BA);  // must do this!
};


#else


#define EXT_ extern "C++"

#ifndef TERMINAL
extern "C++" LOGstream Xlog;
#endif


#endif


EXT_ QString qt_path;
EXT_ QString root_path;

EXT_ QApplication *ptrAPP;
EXT_ QTextCodec *sysCodec;
EXT_ QLocale sysLocale;

#ifndef TERMINAL

EXT_ mainform *ptrMW;

#else

EXT_ void *ptrMW;

#endif

EXT_ QString prjfile;
EXT_ MainDataX MD;
EXT_ vector<ExternalModule> used_modules;
EXT_ State S;
EXT_ vector<AIMData> AD;
EXT_ GREEN grf;
EXT_ NearMatrix MAT;
EXT_ AIMsolver SOL;


#endif
