//
// Graph utils
// (c) 28.1.2004 Ingo D. Rullhusen
//


#ifndef GRAPHCLASS_H
#define GRAPHCLASS_H


#include <vector>

using namespace std;


class Node
{
   public:
      int number;
      int index;
      vector<Node*> neighlist;
      bool used;

      Node();
      ~Node();
};


class Graph
{
   public:
      int no_of_nodes;
      Node *node;

      Graph( int no_of_nodes );
      ~Graph();

      void insert_edge( int no1, int no2 );

      void level_structure( int &len, Node **last_min, Node *root );

      void reverse_Cuthill_McKee();
};


#endif
