//
// Class for green function WITH BOUND
// (c) 23.4.2006 Ingo D. Rullhusen
//

#ifndef GREEN_FREESPACE_H 
#define GREEN_FREESPACE_H

#include <complex>

#include "maindatax.h"

using namespace std;


struct POINT
{
   double x, y, z;
};


class GREEN
{
   public:
      GREEN();
      ~GREEN();

      bool EP_green( complex<double> &grfvp, complex<double> &grfdiv,
                     const POINT ap, const POINT qp );

      bool EF_green( complex<double> G[3][3],
                     const POINT ap, const POINT qp );


      void FT_EP_green( complex<double> &FTgrfvp, complex<double> &FTgrfdiv,
                        const double kx, const double ky, const double kz );


      void FFT_EP_green( complex<double> &FTgrfvp, complex<double> &FTgrfdiv,
                         int &index,
                         const int kx, const int ky, const int kz );


      void FFT_EF_green( complex<double> G[3][3],
                         int &index,
                         const int kx, const int ky, const int kz );


      void setup( const MainData *MD, double R );
      void clear();

   private:
      double k0, k0q;
      double R;

      double prefac_v;
      double prefac_div;
      double prefac_E;
      complex<double> prefac_ff, prefac_fte;

      double delta_k[3];

      complex<double> jk0R, expmjk0R;

      int sx, sy, sz;
      complex<double> *FT_grf;
      complex<double> *FT_grfExx, *FT_grfExy, *FT_grfExz,
                      *FT_grfEyx, *FT_grfEyy, *FT_grfEyz,
                      *FT_grfEzx, *FT_grfEzy, *FT_grfEzz;
};


#endif
