//
// main data class
// (c) 12.3.2007 Ingo D. Rullhusen
//

#ifndef MAIN_DATA_X_H
#define MAIN_DATA_X_H

#include <fstream>

#include "maindata.h"

using namespace std;

typedef enum { ACM_SPCDOM=0, ACM_FFT } AIMcorrMode;

class MainDataX : public MainData
{
   public:
// solver
      AIMcorrMode AIMcm;
      int precon, max_itno;
      double epsilon;

// extract
      bool coeff;
      int coeff_numbering, coeff_vec;
      int coeff_from, coeff_to;

      bool near_field;
      double nfp_x, nfp_y, nfp_z;

      bool far_field;
      int pad_x, pad_y, pad_z;
      int itpl_deg;
      int no_theta, no_phi;
      bool radiated_pwr;


      void reset();
      void write( fstream &file );
      void read( fstream &file );
};

#endif
