//
// Class for near part matrix
// (c) 18.8.2006 Ingo D. Rullhusen
//


#ifndef NEARMATRIX_H
#define NEARMATRIX_H

#include <complex>
#include <fstream>


#include "sparse_matrix.h"


class NearMatrix
{
   public:
      SparseMatrix< complex<double> > *Z;
      SparseMatrix< complex<float> > *L;

      int no_of_modules;    // modules for matrix
      int *modno;           // global mod no
      int *start_idx_mod;   // & dummy at end


      NearMatrix();
      ~NearMatrix();

      void read_binary( fstream &file );
      void write_binary( fstream &file ) const;

      void setup();
      void clear();
};


#endif
