/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/


#include "global_vars.h"


void Pattern2D::update_scan_parameter(){ update_scan_parameter(false); }
void Pattern2D::update_scan_parameter( bool force_alloc )
{
   bool run_ds = false;

   theta = sysLocale.toDouble(Theta->text())*M_PI/180.0;
   if ( Theta->isModified() )
   {
      Theta->setText( sysLocale.toString( theta*180.0/M_PI, 'g', 10) );
      Theta->clearModified();
      run_ds = true;
   }

   phi = sysLocale.toDouble(Phi->text())*M_PI/180.0;
   if ( Phi->isModified() )
   {
      Phi->setText( sysLocale.toString( phi*180.0/M_PI, 'g', 10) );
      Phi->clearModified();
      run_ds = true;
   }

   psi = sysLocale.toDouble(Psi->text())*M_PI/180.0;
   if ( Psi->isModified() )
   {
      Psi->setText( sysLocale.toString( psi*180.0/M_PI, 'g', 10) );
      Psi->clearModified();
      run_ds = true;
   }

   pol = sysLocale.toDouble(Pol->text())*M_PI/180.0;
   if ( Pol->isModified() )
   {
      Pol->setText( sysLocale.toString( pol*180.0/M_PI, 'g', 10) );
      Pol->clearModified();
      run_ds = true;
   }

   start = sysLocale.toDouble(Start->text())*M_PI/180.0;
   if ( Start->isModified() )
   {
      Start->setText( sysLocale.toString( start*180.0/M_PI, 'g', 10) );
      Start->clearModified();
      run_ds = true;
   }

   stop = sysLocale.toDouble(Stop->text())*M_PI/180.0;
   if ( Stop->isModified() )
   {
      Stop->setText( sysLocale.toString( stop*180.0/M_PI, 'g', 10) );
      Stop->clearModified();
      run_ds = true;
   }

   samples = sysLocale.toInt(Samples->text());
   samples = ( samples < 0 ? 0 : samples );
   if ( Samples->isModified() || force_alloc )
   {
      Samples->setText( sysLocale.toString(samples) );
      Samples->clearModified();
      run_ds = true;

      delete [] angle;
      angle = new double[samples];
      delete [] yr;
      yr = new double[samples];
      delete [] yc;
      yc = new double[samples];
   }

#ifndef TERMINAL
   if ( run_ds ) emit scan_parameter_changed( theta, phi, psi,
                                              pol,
                                              start, stop, samples );
#endif
}


#define set_sbuff_blocked_( var ) \
 var->blockSignals(true); \
 var->setText( sysLocale.toString( atof( sbuff.c_str() ) ) ); \
 var->blockSignals(false);

#define set_blocked_( name, func, val ) \
  name->blockSignals(true); \
  name->func( val ); \
  name->blockSignals(false);

void Pattern2D::read( fstream &file )
{
   int i;
   fstream::pos_type pos;
   string sbuff = "";

   pos = file.tellg();

   while ( file.good() && sbuff != "Pattern2D" )
   { sbuff = get_section_label( file, true ); }

   if ( sbuff != "Pattern2D" )
   {
      file.clear();
      file.seekg( pos );
      return;
   }

   setUpdatesEnabled(false);

   file >> sbuff;
   set_sbuff_blocked_( Theta )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Phi )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Psi )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Pol )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Start )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Stop )
   goto_next_line( file );

   file >> i;
   set_blocked_( Samples, setText, sysLocale.toString(i) )
   goto_next_line( file );


   file >> i;
   set_blocked_( Yaxis, setCurrentItem, i );
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Miny )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Maxy )
   goto_next_line( file );


   file >> i;
   set_blocked_( RefPolStyle, setCurrentItem, i )
   goto_next_line( file );

   file >> i;
   set_blocked_( CrossPolStyle, setCurrentItem, i )
   goto_next_line( file );


   file >> i;
   set_blocked_( Xtics, setValue, i );
   goto_next_line( file );

   file >> i;
   set_blocked_( Ytics, setValue, i );

   if ( file.fail() ) throw("read error in pattern2d section");

#ifndef TERMINAL
   init();
#endif

   setUpdatesEnabled(true);
}

void Pattern2D::write( fstream &file )
{
   setUpdatesEnabled(false);

   file << "[Pattern2D]" << endl;

   file << sysLocale.toDouble(Theta->text()) << "   #theta" << endl;
   file << sysLocale.toDouble(Phi->text())   << "   #phi" << endl;
   file << sysLocale.toDouble(Psi->text())   << "   #psi" << endl;

   file << sysLocale.toDouble(Pol->text()) << "   #polarization" << endl;

   file << sysLocale.toDouble(Start->text()) << "   #start" << endl;
   file << sysLocale.toDouble(Stop->text())  << "   #stop" << endl;
   file << sysLocale.toInt(Samples->text())  << "   #samples" << endl;

   file << Yaxis->currentItem() << "   #y-axis" << endl;
   file << sysLocale.toDouble(Miny->text()) << "   #min y" << endl;
   file << sysLocale.toDouble(Maxy->text()) << "   #max y" << endl;

   file << RefPolStyle->currentItem()   << "   #ref. pol. style" << endl;
   file << CrossPolStyle->currentItem() << "   #cross pol. style" << endl;

   file << Xtics->value() << "   #x tics" << endl;
   file << Ytics->value() << "   #y tics" << endl;

   setUpdatesEnabled(true);
}

void Pattern2D::update_calc()
{
   complex<double> *Er, *Ec, E[3], Eref;

   Er = new complex<double>[samples];
   Ec = new complex<double>[samples];

   double rmat[3][3], sw;

   try
   {
      if ( SOL.ff == NULL ) throw( "far-field data not present" );

      for ( int i=0; i<samples; i++ )
      {
         sw = ( samples>1 ? i*(stop-start) / (samples-1) + start : 0.5*(stop+start) );

         rotmat( rmat, 1.0, pol, sw, psi, theta, phi );

         angle[i] = sw * 180.0/M_PI;

         SOL.ff->E_ff( E, rmat[0][2], rmat[1][2], rmat[2][2], MD.itpl_deg );

         Er[i] = rmat[0][0] * E[0] + rmat[1][0] * E[1] + rmat[2][0] * E[2];
         Ec[i] = rmat[0][1] * E[0] + rmat[1][1] * E[1] + rmat[2][1] * E[2];
      }

      rotmat( rmat, 1.0, pol, 0.0, psi, theta, phi );
      SOL.ff->E_ff( E, rmat[0][2], rmat[1][2], rmat[2][2], MD.itpl_deg );
      Eref = rmat[0][0] * E[0] + rmat[1][0] * E[1] + rmat[2][0] * E[2];
   }
   catch ( const char *str )
   {
      Eref = complex<double>(1.0,0.0);
      for ( int i=0; i<samples; i++ )
      {
         angle[i] = ( samples>1 ? i*(stop-start) / (samples-1) + start : 0.5*(stop+start) );
         Er[i] = Ec[i] = complex<double>(0.0,0.0);
      }
      Xlog << endl;
      Xlog << "far-field not calculated: " << str << "!" << endl;
   }


   for ( int i=0; i<samples; i++ )
   {
      switch ( Yaxis->currentItem() )
      {
         case 0: { /*"E/E0\nin dB"*/
                   yr[i] = 20.0*log10( abs(Er[i])/abs(Eref) );
                   yc[i] = 20.0*log10( abs(Ec[i])/abs(Eref) );
                   break; }
         case 1: { /*"E/E0"*/
                   yr[i] = abs(Er[i])/abs(Eref);
                   yc[i] = abs(Ec[i])/abs(Eref);
                   break; }
         case 2: { /*"RCS\nin dB"*/
                   yr[i] = 10.0*log10( 4.0*M_PI*abs(Er[i]*conj(Er[i])) / (MD.wavelength*MD.wavelength) );
                   yc[i] = 10.0*log10( 4.0*M_PI*abs(Ec[i]*conj(Ec[i])) / (MD.wavelength*MD.wavelength) );
                   break; }
         case 3: { /*"RCS"*/
                   yr[i] = 4.0*M_PI*abs(Er[i]*conj(Er[i])) / (MD.wavelength*MD.wavelength);
                   yc[i] = 4.0*M_PI*abs(Ec[i]*conj(Ec[i])) / (MD.wavelength*MD.wavelength);
                   break; }
         default: { throw( "wrong y-axis selection" ); }
      }
   }


   delete [] Ec;
   delete [] Er;

#ifndef TERMINAL
   emit plot_values_changed();
#endif
}

void Pattern2D::export_image()
{
   fstream file;
   QString fn = GetSavePlotName();
#ifndef TERMINAL
   QPixmap PIX = QPixmap::grabWidget(Plot);
#endif

   if ( fn != "" )
   {
      QString ext = fn.section( '.', -1 );

#ifndef TERMINAL
      if ( ext.upper() == "DATA" )
      {
#endif
         file.open( sysCodec->fromUnicode(fn), ios::out );
         file.precision(15);
         file << "# " << Yaxis->currentText() << endl;
         file << "# angle/°  &  ref  &  cross" << endl;
         for ( int i=0; i<samples; i++ )
         {
            file << angle[i] << " " << yr[i] << " " << yc[i] << endl;
         }
         if ( file.fail() )
         {
            Xlog << "cannot save \"" << fn << "!" << endl;
         }
         else
         {
            Xlog << "plot data saved as \"" << fn << "\"." << endl;
         }
         file.close();
#ifndef TERMINAL
      }
      else
      {
         if ( PIX.save( fn, ext.upper(), 100 ) )
         {
            Xlog << "plot exported as \"" << fn << "\"." << endl;
         }
         else
         {
            Xlog << "cannot save \"" << fn << "\", wrong extension?" << endl;
         }
      }
#endif
   }
}




#ifndef TERMINAL
// GUI stuff

void Pattern2D::init()
{
   samples = 0;
   angle = NULL;
   yr = NULL;
   yc = NULL;
}

void Pattern2D::destroy()
{
   delete [] angle;
   delete [] yr;
   delete [] yc;
}



int Pattern2D::exec_2dpattern()
{
   Scan->setup_geo();

   update_scan_parameter(true);
   emit scan_parameter_changed( theta, phi, psi,
                                pol,
                                start, stop, samples );

   return( exec() );
}


void Pattern2D::update_plot()
{
   if ( samples < 1 )
   {
      Plot->clear();
      return;
   }

   QString ylabel;

   switch ( Yaxis->currentItem() )
   {
      case 0: { ylabel = tr("E/E0\nin dB"); break; }
      case 1: { ylabel = tr("E/E0"); break; }
      case 2: { ylabel = tr("RCS\nin dB"); break; }
      case 3: { ylabel = tr("RCS"); break; }
      default: { throw( "wrong y-axis selection" ); }
   }

   setUpdatesEnabled(false);

   double miny = sysLocale.toDouble(Miny->text());
   Miny->setText( sysLocale.toString( miny, 'g', 10) );

   double maxy = sysLocale.toDouble(Maxy->text());
   Maxy->setText( sysLocale.toString( maxy, 'g', 10) );

   uint xtics = Xtics->value();
   uint ytics = Ytics->value();

   Plot->clear();
   Plot->frame( start*180.0/M_PI, stop*180.0/M_PI, xtics, tr("angle/°"),
                miny, maxy, ytics, ylabel,
                "" );

   setUpdatesEnabled(true);

   PenStyle ps;
   PointStyle pts;

   switch ( RefPolStyle->currentItem() )
   {
      case 0: { ps = Qt::NoPen; pts = NONE; break; }
      case 1: { ps = Qt::SolidLine; pts = NONE; break; }
      case 2: { ps = Qt::SolidLine; pts = TIMES; break; }
      case 3: { ps = Qt::SolidLine; pts = PLUS; break; }
      case 4: { ps = Qt::SolidLine; pts = STAR; break; }
      case 5: { ps = Qt::SolidLine; pts = BOX; break; }
      case 6: { ps = Qt::SolidLine; pts = DIAMOND; break; }
      default: { throw( "unknown ref pol style selection" ); }
   }

   if ( ps != Qt::NoPen && samples > 0 )
      Plot->plot( angle, yr, samples, tr("ref."), Qt::red, ps, pts, 1 );


   switch ( CrossPolStyle->currentItem() )
   {
      case 0: { ps = Qt::NoPen; pts = NONE; break; }
      case 1: { ps = Qt::SolidLine; pts = NONE; break; }
      case 2: { ps = Qt::SolidLine; pts = TIMES; break; }
      case 3: { ps = Qt::SolidLine; pts = PLUS; break; }
      case 4: { ps = Qt::SolidLine; pts = STAR; break; }
      case 5: { ps = Qt::SolidLine; pts = BOX; break; }
      case 6: { ps = Qt::SolidLine; pts = DIAMOND; break; }
      default: { throw( "unknown ref pol style selection" ); }
   }

   if ( ps != Qt::NoPen && samples > 0 )
      Plot->plot( angle, yc, samples, tr("cross"), Qt::blue, ps, pts, 1 );
}


QString Pattern2D::GetSavePlotName()
{
   QString fn;
   QFileDialog fd( MD.PrjPath,
                   tr("All files (*)"),
                   this,
                   tr("save image dialog"),
                   true );
   fd.setMode( QFileDialog::AnyFile );
   fd.setCaption(tr("Save image"));

   QStringList list = QImage::outputFormatList();
   QStringList::Iterator it = list.begin();
   while( it != list.end() )
   {
      fd.addFilter( tr("Image (*.") + *it + " *." + (*it).lower() + ")" );
      ++it;
   }
   fd.addFilter( tr("Data (*.DATA *.data)", "don't transl. file ext.") );
   fd.setSelectedFilter(tr("All files (*)"));

   if ( fd.exec() == QDialog::Accepted )
      fn = fd.selectedFile();
   else
      fn = "";

   return(fn);
}


void Pattern2D::keyPressEvent( QKeyEvent * e )
{
   switch ( e->key() )
   {
      case Qt::Key_Return:
      {
         emit returnPressed();
         e->accept();
         return;
      }
      default: {}
   }
}


// end GUI stuff
#endif

