/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/


#include "MyEvents.h"
#include "global_vars.h"


void Pattern3D::write( fstream &file )
{
   setUpdatesEnabled(false);

   file << "[Pattern3D]" << endl;



// incomplete
   file << sysLocale.toDouble(Miny->text()) << "   #min cut-off" << endl;
   file << sysLocale.toDouble(Level->text())   << "   #level" << endl;

   file << sysLocale.toDouble(Theta->text()) << "   #theta" << endl;
   file << sysLocale.toDouble(Phi->text())   << "   #phi" << endl;
   file << sysLocale.toDouble(Psi->text())   << "   #psi" << endl;



   setUpdatesEnabled(true);
}

#define set_sbuff_blocked_( var ) \
 var->blockSignals(true); \
 var->setText( sysLocale.toString( atof( sbuff.c_str() ) ) ); \
 var->blockSignals(false);

#define set_blocked_( name, func, val ) \
  name->blockSignals(true); \
  name->func( val ); \
  name->blockSignals(false);

void Pattern3D::read( fstream & file )
{
   fstream::pos_type pos;
   string sbuff = "";

   pos = file.tellg();

   while ( file.good() && sbuff != "Pattern3D" )
   { sbuff = get_section_label( file, true ); }

   if ( sbuff != "Pattern3D" )
   {
      file.clear();
      file.seekg( pos );
      return;
   }

   setUpdatesEnabled(false);


   file >> sbuff;
   set_sbuff_blocked_( Miny )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Level )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Theta )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Phi )
   goto_next_line( file );

   file >> sbuff;
   set_sbuff_blocked_( Psi )
   goto_next_line( file );


   setup_paras();


   setUpdatesEnabled(true);
}


void Pattern3D::setup_paras()
{
   bool run_ff = false;
   bool run_lvl = false;
   bool run_rp = false;


   min_cutoff = sysLocale.toDouble(Miny->text());
   if ( Miny->isModified() )
   {
      Miny->setText( sysLocale.toString( min_cutoff, 'g', 10) );
      Miny->clearModified ();
      run_ff = true;
   }


   level = sysLocale.toDouble(Level->text());
   if ( Level->isModified() )
   {
      Level->setText( sysLocale.toString( level, 'g', 10) );
      Level->clearModified ();
      run_lvl = true;
   }


   theta = sysLocale.toDouble(Theta->text())*M_PI/180.0;
   if ( Theta->isModified() )
   {
      Theta->setText( sysLocale.toString( theta*180.0/M_PI, 'g', 10) );
      Theta->clearModified ();
      run_rp = true;
   }

   phi = sysLocale.toDouble(Phi->text())*M_PI/180.0;
   if ( Phi->isModified() )
   {
      Phi->setText( sysLocale.toString( phi*180.0/M_PI, 'g', 10) );
      Phi->clearModified();
      run_rp = true;
   }

   psi = sysLocale.toDouble(Psi->text())*M_PI/180.0;
   if ( Psi->isModified() )
   {
      Psi->setText( sysLocale.toString( psi*180.0/M_PI, 'g', 10) );
      Psi->clearModified();
      run_rp = true;
   }


#ifndef TERMINAL
   try
   {
      if ( run_rp )            Pattern->setup_refplane( theta, phi, psi );
      if ( run_rp )            Pattern->init_ff( SOL.ff, CoSys->currentText() );
      if ( run_ff || run_rp )  Pattern->setup_ff( Yaxis->currentText(), PolSelect->currentText(), min_cutoff );
      if ( run_lvl || run_ff ) Pattern->setup_level( level );
   }
   catch( const char *str )
   {
      Xlog << "3D pattern closed: " << str << endl;
      reject();
   }

   if ( run_ff || run_lvl || run_rp ) setup_plot();
#endif
}



#ifndef TERMINAL
// GUI stuff

void Pattern3D::exec_3dpattern()
{
   try
   {
      Pattern->clearall();

      setup_paras();
      Pattern->setup_refplane( theta, phi, psi );

      Pattern->init_ff( SOL.ff, CoSys->currentText() );
      Pattern->setup_ff( Yaxis->currentText(), PolSelect->currentText(), min_cutoff );

      Pattern->setup_geo_axes();
      Pattern->setup_level( level );

      setup_plot();
   }
   catch ( const char *str )
   {
      throw(str);
   }

   exec();
}


void Pattern3D::setup_plot()
{
   try
   {
      Pattern->display_pattern( FarField->isChecked(),
                                     Geo->isChecked(),
                                    Axes->isChecked(),
                                lvlMeter->isChecked(),
                                RefPlane->isChecked()  );
    }
   catch( const char *str )
   {
      Xlog << "3D pattern closed: " << str << endl;
      reject();
   }
}

void Pattern3D::setup_ff()
{
   try
   {
      Pattern->setup_ff( Yaxis->currentText(), PolSelect->currentText(), min_cutoff );
      Pattern->display_pattern( FarField->isChecked(),
                                     Geo->isChecked(),
                                    Axes->isChecked(),
                                lvlMeter->isChecked(),
                                RefPlane->isChecked()  );
    }
   catch( const char *str )
   {
      Xlog << "3D pattern closed: " << str << endl;
      reject();
   }
}

void Pattern3D::init_ff()
{
   try
   {
      Pattern->init_ff( SOL.ff, CoSys->currentText() );
      Pattern->setup_ff( Yaxis->currentText(), PolSelect->currentText(), min_cutoff );
      Pattern->display_pattern( FarField->isChecked(),
                                     Geo->isChecked(),
                                    Axes->isChecked(),
                                lvlMeter->isChecked(),
                                RefPlane->isChecked()  );
   }
   catch( const char *str )
   {
      Xlog << "3D pattern closed: " << str << endl;
      reject();
   }
}



void Pattern3D::wheel_level_set( int delta )
{
   double d;

   if ( Yaxis->currentText() == tr("pattern (dB)") )
      d = 1.0;
   else if ( Yaxis->currentText() == tr("pattern (lin.)") )
      d = 0.025;
   else if ( Yaxis->currentText() == tr("RCS (dB)") )
      d = 1.0;
   else if ( Yaxis->currentText() == tr("RCS (lin.)") )
      d = 0.025;
   else
      throw( "unknown r-axis" );

   if      ( delta < 0 ) level += d;
   else if ( delta > 0 ) level -= d;
   else                  return;

   if ( level < min_cutoff ) level = min_cutoff;

   Level->setText( sysLocale.toString( level, 'g', 10) );

   try
   {
      Pattern->setup_level( level );
      setup_plot();
   }
   catch( const char *str )
   {
      Xlog << "3D pattern closed: " << str << endl;
      reject();
   }
}



void Pattern3D::keyPressEvent( QKeyEvent * e )
{
   switch ( e->key() )
   {
      case Qt::Key_Return:
      {
         emit returnPressed();
         e->accept();
         return;
      }
      default: {}
   }
}


// end GUI stuff
#endif

