//
// state class
// (c) 17.3.2006 Ingo D. Rullhusen
//

#ifndef STATE_H
#define STATE_H

#include <fstream>

#include "green.h"


typedef enum { INITIAL=0, GEO_RDY,
               AIM_RDY, MAT_RDY,
               RHS_RDY, SOLVED,
               EXTRACTED } StateValue;


class State
{
   public:
      State();
      ~State();

      void write( fstream &file ) const;
      void read( fstream &file );

      void next();
      void prev();

      void back_to( StateValue s );

      StateValue value() const { return(state_); };

   private:
      StateValue state_;

      void next_();
      void prev_();
};


#endif
