//
// auxiliary qt stuff dummy
// (c) 18.10.2006 Ingo D. Rullhusen
//

#ifndef AUX_QT_H
#define AUX_QT_H

#include "qstring.h"
#include "module_interface.h"
#include "field.h"


double LengthUnitFactor( QString str ){ return(0.0); };
double FreqUnitFactor( QString str ){ return(0.0); };


bool thread_of_geo_setup( ExternalModule *em )
{
   int nomsg;
   string *omsg = NULL;
   bool ok = true;

   try
   {
      em->matrix_geo_setup( &MD, &omsg, &nomsg );

      if ( nomsg > 0 )
      {
         Xlog << "output of \"" << em->name() << "\" >>>" << endl;
      }
      for ( int m=0; m<nomsg; m++ )
      {
         Xlog << omsg[m] << endl;
      }
      if ( nomsg > 0 )
      {
         Xlog << "<<< end of output" << endl;
      }
   }
   catch ( const char *str )
   {
      Xlog << "geo thread error: " << str << endl;
      ok = false;
   }

   delete [] omsg;

   return(ok);
};


bool thread_of_ele_setup( ExternalModule *em )
{
   int nomsg;
   string *omsg = NULL;
   bool ok = true;

   try
   {
      em->matrix_ele_setup( &MD, &omsg, &nomsg );

      if ( nomsg > 0 )
      {
         Xlog << "output of \"" << em->name() << "\" >>>" << endl;
      }
      for ( int m=0; m<nomsg; m++ )
      {
         Xlog << omsg[m] << endl;
      }
      if ( nomsg > 0 )
      {
         Xlog << "<<< end of output" << endl;
      }
   }
   catch ( const char *str )
   {
      Xlog << "geo thread error: " << str << endl;
      ok = false;
   }

   delete [] omsg;

   return(ok);
}


bool thread_of_rhs_setup( ExternalModule *em )
{
   int nomsg;
   string *omsg = NULL;
   bool ok = true;

   try
   {
      em->RHS_E_setup( &MD, &omsg, &nomsg );

      if ( nomsg > 0 )
      {
         Xlog << "output of \"" << em->name() << "\" >>>" << endl;
      }
      for ( int m=0; m<nomsg; m++ )
      {
         Xlog << omsg[m] << endl;
      }
      if ( nomsg > 0 )
      {
         Xlog << "<<< end of output" << endl;
      }
   }
   catch ( const char *str )
   {
      Xlog << "geo thread error: " << str << endl;
      ok = false;
   }

   delete [] omsg;

   return(ok);
}

bool thread_of_extract_setup( ExternalModule *em, FIELD *f )
{
   int nomsg;
   string *omsg = NULL;
   bool ok = true;

   try
   {
      em->extract_run( &MD,
                       &SOL.J[em->matrix_offset()],
                       em->no_of_bfkt(),
                       f, &omsg, &nomsg );

      if ( nomsg > 0 )
      {
         Xlog << "output of \"" << em->name() << "\" >>>" << endl;
      }
      for ( int m=0; m<nomsg; m++ )
      {
         Xlog << omsg[m] << endl;
      }
      if ( nomsg > 0 )
      {
         Xlog << "<<< end of output" << endl;
      }
   }
   catch ( const char *str )
   {
      Xlog << "geo thread error: " << str << endl;
      ok = false;
   }

   delete [] omsg;

   return(ok);
}


#endif
