//
// Quasidummy Class for Pattern3D
// (c) 6.6.2007 Ingo D. Rullhusen
//

#ifndef OGL3DPATTERN_H
#define OGL3DPATTERN_H

#include <fstream>

#include "qstring.h"

class OGL3dpattern
{
   public:
// TERMINAL only
      string fn;

// designer
      double R;
      double lx[3], ly[3], lz[3];   // dipole/ref global x -> local z

      QString coordinates;
      int notheta, nophi;
      complex<double> *RefValue, *CrossValue;
      double MaxValue;

      bool lvlM;
      int mpy;
      double rmax, rmin;

      OGL3dpattern();
      ~OGL3dpattern();

      void clearall();

      void setup_refplane( double theta, double phi, double psi );
      void init_ff( FARFIELD *FF, QString cosys );   // (refplane, cosys)
      void write_ffsph( fstream &file ) const;

      static QString tr( QString sourceText ){ return(sourceText); }
};


#endif
