//
// Quasidummy Class for Pattern2D
// (c) 25.10.2006 Ingo D. Rullhusen
//

#ifndef PATTERN2D_H
#define PATTERN2D_H

#include <fstream>


#include "auxiliary.h"
#include "rotmat.h"

#include "qstring.h"
#include "qlineedit.h"
#include "qcombobox.h"
#include "qspinbox.h"


// set by designer
const int yano = 4;
const string yatxt[] = { "pattern (dB)",
                         "pattern (lin.)",
                         "RCS (dB)",
                         "RCS (lin.)"
                       };

const int lstyno = 7;
const string lsty[] = { "(none)",
                        "plain",
                        "times",
                        "plus",
                        "star",
                        "box",
                        "diamond"
                      };


class Pattern2D
{
   public:
// TERMINAL only
      string fn;

// designer
      double theta, phi, psi, pol, start, stop;
      int samples;
      double *angle, *yr, *yc;

// GUI
      QLineEdit *Theta, *Phi, *Psi, *Pol, *Start, *Stop;
      QLineEdit *Samples;

      QComboBox *Yaxis;

      QLineEdit *Miny, *Maxy;
      QComboBox *RefPolStyle, *CrossPolStyle;

      QSpinBox *Xtics, *Ytics;


      Pattern2D()
      {
         samples = 0;
         angle = yr = yc = NULL;

         Theta = new QLineEdit();
         Phi = new QLineEdit();
         Psi = new QLineEdit();
         Pol = new QLineEdit();
         Start = new QLineEdit();
         Stop = new QLineEdit();

         Samples = new QLineEdit();

         Yaxis = new QComboBox( yano, yatxt );

         Miny = new QLineEdit();
         Maxy = new QLineEdit();

         RefPolStyle = new QComboBox( lstyno, lsty );
         CrossPolStyle = new QComboBox( lstyno, lsty );

         Xtics = new QSpinBox();
         Ytics = new QSpinBox();
      }

      ~Pattern2D()
      {
         delete [] angle;
         delete [] yr;
         delete [] yc;

         delete Theta;
         delete Phi;
         delete Psi;
         delete Pol;
         delete Start;
         delete Stop;

         delete Samples;

         delete Yaxis;

         delete Miny;
         delete Maxy;

         delete RefPolStyle;
         delete CrossPolStyle;

         delete Xtics;
         delete Ytics;
      }

      void read( fstream &file );
      void write( fstream &file );

      QString GetSavePlotName(){ return(fn); };

      void update_scan_parameter();
      void update_scan_parameter( bool force_alloc );

      void update_calc();
      void export_image();

      void setUpdatesEnabled( bool enable ){};
};

#include "../pattern2d.ui.h"


#endif
