//
// Quasidummy Class for Pattern3D
// (c) 6.6.2007 Ingo D. Rullhusen
//

#ifndef PATTERN3D_H
#define PATTERN3D_H

#include <fstream>


#include "auxiliary.h"
#include "rotmat.h"

#include "ogl3dpattern.h"

#include "qlineedit.h"


class Pattern3D
{
   public:
// TERMINAL only
      string fn;

// designer
      double min_cutoff;
      double level;
      double theta, phi, psi;

// GUI
      OGL3dpattern Pattern;
      QLineEdit *Miny, *Level;
      QLineEdit *Theta, *Phi, *Psi;

      Pattern3D()
      {
         Miny = new QLineEdit();
         Level = new QLineEdit();

         Theta = new QLineEdit();
         Phi = new QLineEdit();
         Psi = new QLineEdit();
      }

      ~Pattern3D()
      {
         delete Theta;
         delete Phi;
         delete Psi;
      }

      void read( fstream &file );
      void write( fstream &file );

      void setup_paras();

      void setUpdatesEnabled( bool enable ){};
};

#include "../pattern3d.ui.h"


#endif
