//
// Dummy Class for QComboBox
// (c) 22.3.2007 Ingo D. Rullhusen
//

#ifndef QCOMBOBOX
#define QCOMBOBOX

#include <vector>


class QComboBox
{
   public:
      QComboBox( int no, const string *str ) : item(0)
      {
         item_text.clear();
         for ( int i=0; i<no; i++ ) item_text.push_back(str[i]);
      }

      void setCurrentItem ( int index ){ item = index; }
      int currentItem() const { return(item); }
      int count() const { return( item_text.size() ); }

      QString currentText() const
      {
#ifdef BOUNDARY_CHECK
         if ( item < 0 || item >= (int)item_text.size() )
         {
            cerr << "Error in dummy QComboBox(): line "
                 << __LINE__ << "!" << endl;
            exit(1);
         }
#endif
         return( item_text[item] );
      }

      void blockSignals( bool block ){}

   private:
      int item;
      vector<string> item_text;

};


#endif
