/*
*  Zeros of a function
*  (c) 30.3.2001 Ingo D. Rullhusen
*/

#include <math.h>

double zero( double (*func)(double), double lb, double ub, double error )
{
   double x1, x2, xp, f1, f2;
   
   x1 = lb;
   x2 = ub;
   f1 = func(x1);

   while ( fabs(x1-x2) > error )
   {
      f2 = func(x2);
      if ( fabs(f1-f2) < error ) break;
      xp = ( x2*f1 - x1*f2 ) / ( f1 - f2 );
      x1 = x2;
      f1 = f2;
      x2 = xp;
   }
   return(x2);
}
